#########################################################################
# Copyright (c) 2011 KSI Labs, LLC. All rights reserved.		#
# Written by Sergey Kubushyn <ksi@koi8.net>, <ksi@ksilabs.com>.		#
#########################################################################
# File: centipede_pci.sdc						#
#									#
# TimeQuest constraints file for the entire design. Fitter should be	#
# set to multicorner (both Slow and Fast corner constraints used for	#
# placement/routing so all timing requirements will be met.)		#
#########################################################################


#########################################################################
#			LICENSE and Terms of Use.			#
#									#
# First of all, this is NOT GPL or Free Software. It is open so you	#
# have the VHDL source code. There is also the source code for the	#
# Windows Engine for Mach3 CNC software available from KSI Labs, LLC	#
# website, http://www.ksilabs.com.					#
#									#
# You are free to use this particular VHDL code, make modifications to	#
# customize it for your own needs, fix inevitable bugs, port it to 	#
# other CNC software and do anything else as long as your derivative	#
# work that is based on this code or uses parts or pieces thereof is	#
# made to be used with any KSI Labs, LLC products.			#
#									#
# We do NOT grant you a permission to use any parts of this code in	#
# any products that are designed for products not manufactured or	#
# distributed by KSI Labs, LLC. We might give such a permission on	#
# case-by-case basis but it is not legal to use this code or bits and	#
# pieces thereof with products not coming from KSI Labs, LLC without	#
# our explicit written permission.					#
#									#
# The original copyright notices must be included in all derivative	#
# works. You do NOT have to ask our permission to make any changes to	#
# this code and you are not under obligation to give us any of your	#
# work back as long as you are using it for your own needs.		#
#									#
# However we do NOT give our permission to distribute your derivative	#
# work unless all original copyrights are retained, all the conditions	#
# of this license are met (use only with KSI Labs, LLC products) and	#
# full source code for such derivative work is available for free to	#
# everybody without any further conditions including but not limited	#
# to signing any kinds of NDA. We explicitely deny any permission to	#
# distribute any derivative work based on this code with closed source	#
# binary-only fragments or include bits or pieces of this code in such	#
# products. That essentially means that it is NOT legal to use it with	#
# ANY proprietary HDL megafunctions, megacores, etc. if the resulting	#
# product is distributed. It IS legal to use whatever you want if the	#
# resulting product is made for use with a KSI Labs, LLC product AND	#
# that resulting product is not distributed. Exclusions can be granted	#
# by KSI Labs, LLC on case-by-case basis.				#
#########################################################################


create_clock -period 30.000 -name {l_clk} {l_clk}
create_generated_clock -name spi_clk -source [get_ports {l_clk}] -divide_by 64 {spi_clk}
create_clock -period 30.000 -name pci_clk
create_generated_clock -name spi_clk_virt -source [get_ports {l_clk}] -divide_by 64


set_max_delay 7 -from [get_ports {ext[*]}] -to [get_registers *]
set_max_delay 7 -from [get_ports {d_in[*]}] -to [get_registers *]
set_max_delay 7 -from [get_ports {l_ad[*]}] -to [get_registers *]
set_max_delay 7 -from [get_ports {l_cbe[*]}] -to [get_registers *]
set_max_delay 7 -from [get_ports {l_frame}] -to [get_registers *]
set_max_delay 7 -from [get_ports {l_irdy}] -to [get_registers *]
set_max_delay 7 -from [get_ports {l_idsel}] -to [get_registers *]
set_max_delay 7 -from [get_ports {l_rst}] -to [get_registers *]
set_max_delay 7 -from [get_ports {liso2}] -to [get_registers *]


set_min_delay -10 -from [get_ports {ext[*]}] -to [get_registers *]
set_min_delay -10 -from [get_ports {d_in[*]}] -to [get_registers *]
set_min_delay 0.0 -from [get_ports {l_ad[*]}] -to [get_registers *]
set_min_delay 0.0 -from [get_ports {l_cbe[*]}] -to [get_registers *]
set_min_delay 0.0 -from [get_ports {l_frame}] -to [get_registers *]
set_min_delay 0.0 -from [get_ports {l_irdy}] -to [get_registers *]
set_min_delay 0.0 -from [get_ports {l_idsel}] -to [get_registers *]
set_min_delay -10 -from [get_ports {l_rst}] -to [get_registers *]
set_min_delay -10 -from [get_ports {liso2}] -to [get_registers *]


set_output_delay 0.0 -clock pci_clk [get_ports {d_out[*]}]
set_output_delay 0.0 -clock pci_clk [get_ports {ext[*]}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_inta}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_stop}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_devsel}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_trdy}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_par}]
set_output_delay 0.0 -clock pci_clk [get_ports {l_ad[*]}]
set_output_delay 0.0 -clock spi_clk_virt [get_ports {losi*}]
set_output_delay 0.0 -clock spi_clk_virt [get_ports {lpck*}]
set_output_delay 0.0 -clock spi_clk_virt [get_ports {lss*}]


set_max_delay 11 -from [get_keepers {pci32ttiny:u1|devsel}] -to [get_ports {l_devsel}]
set_max_delay 11 -from [get_keepers {pci32ttiny:u1|trdy}] -to [get_ports {l_trdy}]
set_max_delay 11 -from [get_keepers {pci32ttiny:u1|tgt_oe}] -to [get_ports {l_devsel}]
set_max_delay 11 -from [get_keepers {pci32ttiny:u1|par_out}] -to [get_ports {l_par}]
set_max_delay 28 -from [get_keepers {pci32ttiny:u1|pci_data_oe}] -to [get_ports {l_ad[*]}]
set_max_delay 28 -from [get_keepers {pci32ttiny:u1|tgt_oe}] -to [get_ports {l_trdy}]
set_max_delay 28 -from [get_keepers {pci32ttiny:u1|pci_par_oe}] -to [get_ports {l_par}]


set_multicycle_path -from {dac_a_reg[*]} -to {tlv5617a_dac:u2|thr[*]} -hold -start 1
set_multicycle_path -from {dac_b_reg[*]} -to {tlv5617a_dac:u2|thr[*]} -hold -start 1
